SetCompressor bzip2
!include "MUI.nsh"
!include "WinMessages.NSH"

!define MUI_PRODUCT "Portable.NET (Light)"
!define MUI_VERSION "0.6.0"

!define MUI_WELCOMEPAGE
!define MUI_LICENSEPAGE
!define MUI_COMPONENTSPAGE
!define MUI_DIRECTORYPAGE
!define MUI_PAGEINSTFILES
!define MUI_PAGEFINISH

!define MUI_UNPAGEINSTFILES

!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\README.txt"
!define MUI_ABORTWARNING

!define MUI_UNINSTALLER
!define MUI_ICON "${NSISDIR}\Contrib\Icons\Setup.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\normal-uninstall.ico"

!insertmacro MUI_LANGUAGE "English"


OutFile "PNET-0-6-0-Installer-Light.exe"
InstallDir "C:\PNET"
InstallDirRegKey  HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\cscc.exe" ""
LicenseBkColor 0x00FFFFFF
LicenseData "C:\PNET\GPL.txt"
ShowInstDetails hide
ShowUnInstDetails hide

Section "Portable.NET " SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\..\PNET\GPL.txt"
  File "..\..\PNET\README.txt"
  SetOutPath "$INSTDIR\bin"
  File "..\..\PNET\bin\ilverify.exe"
  File "..\..\PNET\bin\ilstrip.exe"
  File "..\..\PNET\bin\ilsize.exe"
  File "..\..\PNET\bin\ilrun.exe"
  File "..\..\PNET\bin\ilranlib.exe"
  File "..\..\PNET\bin\ilnative.exe"
  File "..\..\PNET\bin\ilheader.exe"
  File "..\..\PNET\bin\ilfind.exe"
  File "..\..\PNET\bin\ildd.exe"
  File "..\..\PNET\bin\ildasm.exe"
  File "..\..\PNET\bin\ilasm.exe"
  File "..\..\PNET\bin\ilalink.exe"
  File "..\..\PNET\bin\cssrc2html.exe"
  File "..\..\PNET\bin\csdoc.exe"
  File "..\..\PNET\bin\csdoc2texi.exe"
  File "..\..\PNET\bin\csdoc2html.exe"
  File "..\..\PNET\bin\csdoc2hier.exe"
  File "..\..\PNET\bin\cscc.exe"
  File "..\..\PNET\bin\csant.exe"
  File "..\..\PNET\bin\clrwrap.exe"
  File "..\..\PNET\bin\cli-unknown-strip.lnk"
  File "..\..\PNET\bin\cli-unknown-size.lnk"
  File "..\..\PNET\bin\cli-unknown-ranlib.lnk"
  File "..\..\PNET\bin\cli-unknown-gcc.lnk"
  File "..\..\PNET\bin\cli-unknown-ar.lnk"
  File "..\..\PNET\bin\al.exe"
  File "..\..\PNET\bin\resgen.exe"
  SetOutPath "$INSTDIR\HelloWorld"
  File "..\..\PNET\HelloWorld\hello.cs"
  SetOutPath "$INSTDIR\include\pnet"
  File "..\..\PNET\include\pnet\il_xml.h"
  File "..\..\PNET\include\pnet\il_writer.h"
  File "..\..\PNET\include\pnet\il_values.h"
  File "..\..\PNET\include\pnet\il_utils.h"
  File "..\..\PNET\include\pnet\il_types.h"
  File "..\..\PNET\include\pnet\il_thread.h"
  File "..\..\PNET\include\pnet\il_system.h"
  File "..\..\PNET\include\pnet\il_sysio.h"
  File "..\..\PNET\include\pnet\il_serialize.h"
  File "..\..\PNET\include\pnet\il_regex.h"
  File "..\..\PNET\include\pnet\il_program.h"
  File "..\..\PNET\include\pnet\il_profile.h"
  File "..\..\PNET\include\pnet\il_opcodes.h"
  File "..\..\PNET\include\pnet\il_meta.h"
  File "..\..\PNET\include\pnet\il_linker.h"
  File "..\..\PNET\include\pnet\il_jopcodes.h"
  File "..\..\PNET\include\pnet\il_image.h"
  File "..\..\PNET\include\pnet\il_gc.h"
  File "..\..\PNET\include\pnet\il_errno.h"
  File "..\..\PNET\include\pnet\il_engine.h"
  File "..\..\PNET\include\pnet\il_dumpasm.h"
  File "..\..\PNET\include\pnet\il_decimal.h"
  File "..\..\PNET\include\pnet\il_debug.h"
  File "..\..\PNET\include\pnet\il_crypt.h"
  File "..\..\PNET\include\pnet\il_config.h"
  File "..\..\PNET\include\pnet\il_coder.h"
  File "..\..\PNET\include\pnet\il_bignum.h"
  File "..\..\PNET\include\pnet\il_align.h"
  File "..\..\PNET\include\pnet\gc_typed.h"
  File "..\..\PNET\include\pnet\gc_local_alloc.h"
  File "..\..\PNET\include\pnet\gc.h"
  File "..\..\PNET\include\pnet\fficonfig.h"
  File "..\..\PNET\include\pnet\ffi_mips.h"
  File "..\..\PNET\include\pnet\ffi.h"
  File "..\..\PNET\include\pnet\leak_detector.h"
  SetOutPath "$INSTDIR\info"
  File "..\..\PNET\info\pnettools.info-5"
  File "..\..\PNET\info\pnettools.info-4"
  File "..\..\PNET\info\pnettools.info-3"
  File "..\..\PNET\info\pnettools.info-2"
  File "..\..\PNET\info\pnettools.info-1"
  File "..\..\PNET\info\pnettools.info"
  File "..\..\PNET\info\dir"
  SetOutPath "$INSTDIR\lib"
  File "..\..\PNET\lib\libILLink.a"
  File "..\..\PNET\lib\libILImage.a"
  File "..\..\PNET\lib\libILEngine.a"
  File "..\..\PNET\lib\libILDumpAsm.a"
  File "..\..\PNET\lib\libILCodeGen.a"
  File "..\..\PNET\lib\libILAsm.a"
  File "..\..\PNET\lib\libILSupport.a"
  SetOutPath "$INSTDIR\lib\cscc\lib\de"
  File "..\..\PNET\lib\cscc\lib\de\System.resources.dll"
  File "..\..\PNET\lib\cscc\lib\de\mscorlib.resources.dll"
  File "..\..\PNET\lib\cscc\lib\de\I18N.resources.dll"
  File "..\..\PNET\lib\cscc\lib\de\System.Xml.resources.dll"
  SetOutPath "$INSTDIR\lib\cscc\lib"
  File "..\..\PNET\lib\cscc\lib\System.Xml.dll"
  File "..\..\PNET\lib\cscc\lib\System.Windows.Forms.dll"
  File "..\..\PNET\lib\cscc\lib\System.ServiceProcess.dll"
  File "..\..\PNET\lib\cscc\lib\System.Runtime.Serialization.Formatters.Soap.dll"
  File "..\..\PNET\lib\cscc\lib\System.Net.IrDA.dll"
  File "..\..\PNET\lib\cscc\lib\System.Messaging.dll"
  File "..\..\PNET\lib\cscc\lib\System.Management.dll"
  File "..\..\PNET\lib\cscc\lib\System.EnterpriseServices.dll"
  File "..\..\PNET\lib\cscc\lib\System.Drawing.Xsharp.dll"
  File "..\..\PNET\lib\cscc\lib\System.Drawing.Win32.dll"
  File "..\..\PNET\lib\cscc\lib\System.Drawing.Postscript.dll"
  File "..\..\PNET\lib\cscc\lib\System.Drawing.dll"
  File "..\..\PNET\lib\cscc\lib\System.dll"
  File "..\..\PNET\lib\cscc\lib\System.Data.OracleClient.dll"
  File "..\..\PNET\lib\cscc\lib\System.Data.dll"
  File "..\..\PNET\lib\cscc\lib\System.Configuration.Install.dll"
  File "..\..\PNET\lib\cscc\lib\pnetlib.here"
  File "..\..\PNET\lib\cscc\lib\PEAPI.dll"
  File "..\..\PNET\lib\cscc\lib\OpenSystem.C.dll"
  File "..\..\PNET\lib\cscc\lib\Npgsql.dll"
  File "..\..\PNET\lib\cscc\lib\mscorlib.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Posix.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.GetOptions.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Directory.LDAP.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Data.Tds.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Data.PostgreSqlClient.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Data.MySql.dll"
  File "..\..\PNET\lib\cscc\lib\Mono.Data.DB2Client.dll"
  File "..\..\PNET\lib\cscc\lib\Microsoft.Vsa.dll"
  File "..\..\PNET\lib\cscc\lib\Microsoft.VisualC.dll"
  File "..\..\PNET\lib\cscc\lib\Microsoft.VisualBasic.dll"
  File "..\..\PNET\lib\cscc\lib\Microsoft.JScript.dll"
  File "..\..\PNET\lib\cscc\lib\libXsharpSupport.la"
  File "..\..\PNET\lib\cscc\lib\libXsharpSupport.a"
  File "..\..\PNET\lib\cscc\lib\ISymWrapper.dll"
  File "..\..\PNET\lib\cscc\lib\ICSharpCode.SharpZipLib.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.West.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.Rare.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.Other.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.MidEast.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.dll"
  File "..\..\PNET\lib\cscc\lib\I18N.CJK.dll"
  File "..\..\PNET\lib\cscc\lib\DotGNU.SSL.dll"
  File "..\..\PNET\lib\cscc\lib\DotGNU.Images.dll"
  File "..\..\PNET\lib\cscc\lib\Custommarshalers.dll"
  File "..\..\PNET\lib\cscc\lib\cstest.dll"
  File "..\..\PNET\lib\cscc\lib\cscompmgd.dll"
  File "..\..\PNET\lib\cscc\lib\Accessibility.dll"
  File "..\..\PNET\lib\cscc\lib\Xsharp.dll"
  SetOutPath "$INSTDIR\lib\cscc\plugins"
  File "..\..\PNET\lib\cscc\plugins\cscc-cs.exe"
  File "..\..\PNET\lib\cscc\plugins\cscc-csharp.lnk"
  SetOutPath "$INSTDIR\lib\pnet"
  File "..\..\PNET\lib\pnet\libgc.a"
  File "..\..\PNET\lib\pnet\libffi.la"
  File "..\..\PNET\lib\pnet\libffi.a"
  File "..\..\PNET\lib\pnet\libgc.la"
  SetOutPath "$INSTDIR\man\man1"
  File "..\..\PNET\man\man1\ilverify.1"
  File "..\..\PNET\man\man1\ilstrip.1"
  File "..\..\PNET\man\man1\ilsize.1"
  File "..\..\PNET\man\man1\ilrun.1"
  File "..\..\PNET\man\man1\ilranlib.1"
  File "..\..\PNET\man\man1\ilnative.1"
  File "..\..\PNET\man\man1\ilheader.1"
  File "..\..\PNET\man\man1\ilfind.1"
  File "..\..\PNET\man\man1\ildd.1"
  File "..\..\PNET\man\man1\ildasm.1"
  File "..\..\PNET\man\man1\ilasm.1"
  File "..\..\PNET\man\man1\ilalink.1"
  File "..\..\PNET\man\man1\cssrc2html.1"
  File "..\..\PNET\man\man1\csdoc.1"
  File "..\..\PNET\man\man1\csdoc2texi.1"
  File "..\..\PNET\man\man1\csdoc2html.1"
  File "..\..\PNET\man\man1\csdoc2hier.1"
  File "..\..\PNET\man\man1\cscc.1"
  File "..\..\PNET\man\man1\csant.1"
  File "..\..\PNET\man\man1\clrwrap.1"
  File "..\..\PNET\man\man1\resgen.1"
SectionEnd

Section "Portable.NET (Library Source)" SEC02
  SetOutPath "$INSTDIR\Source"
  File "..\..\PNET\Source\pnetlib-0.6.0.zip"
  File "..\..\PNET\Source\ml-pnet-0.6.0.zip"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\al.exe" "" "$INSTDIR\bin\cscc.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "DisplayName" "${MUI_PRODUCT} ${MUI_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "DisplayIcon" "$INSTDIR\bin\cscc.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "DisplayVersion" "0.6.0"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "URLInfoAbout" "http://www.DotGNU.org"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET" "Publisher" "DotGNU"
  ;Set Environment Path
  Push "$INSTDIR\bin"
  Call AddToPath
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "If you are using windows 95/98/ME you must reboot your computer to complete the installation Portable.NET."
SectionEnd

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Portable.NET Binary Files"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Portable.NET Library Source Files"
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END


Function un.onUninstSuccess
  ; Uninstall Environment Path
  Push "$INSTDIR\bin"
  Call un.RemoveFromPath
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Portable.NET was successfully removed from your computer."

FunctionEnd

Function .onInstSuccess
    MessageBox MB_YESNO "Portable.Net was installed successfully. Would you like to view the readme file?" IDNO NoReadme
      Exec "notepad.exe $INSTDIR\README.txt" ; view readme file
    NoReadme:
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove Portable.NET and all of its components?" IDYES +2
  Abort
FunctionEnd

;====================================================
; AddToPath - Adds the given dir to the search path.
;        Input - head of the stack
;        Note - Win9x systems requires reboot
;====================================================
Function AddToPath
  Exch $0
  Push $1

  Call IsNT
  Pop $1
  StrCmp $1 1 AddToPath_NT
    ; Not on NT
    StrCpy $1 $WINDIR 2
    FileOpen $1 "$1\autoexec.bat" a
    FileSeek $1 0 END
    GetFullPathName /SHORT $0 $0
    FileWrite $1 "$\r$\nSET PATH=%PATH%;$0$\r$\n"
    FileClose $1
    Goto AddToPath_done

  AddToPath_NT:
    ReadRegStr $1 HKCU "Environment" "PATH"
    StrCmp $1 "" AddToPath_NTdoIt
      StrCpy $0 "$1;$0"
      Goto AddToPath_NTdoIt
    AddToPath_NTdoIt:
      WriteRegExpandStr HKCU "Environment" "PATH" $0
      SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

  AddToPath_done:
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; RemoveFromPath - Remove a given dir from the path
;     Input: head of the stack
;====================================================
Function un.RemoveFromPath
  Exch $0
  Push $1
  Push $2
  Push $3
  Push $4

  Call un.IsNT
  Pop $1
  StrCmp $1 1 unRemoveFromPath_NT
    ; Not on NT
    StrCpy $1 $WINDIR 2
    FileOpen $1 "$1\autoexec.bat" r
    GetTempFileName $4
    FileOpen $2 $4 w
    GetFullPathName /SHORT $0 $0
    StrCpy $0 "SET PATH=%PATH%;$0"
    SetRebootFlag true
    Goto unRemoveFromPath_dosLoop

    unRemoveFromPath_dosLoop:
      FileRead $1 $3
      StrCmp $3 "$0$\r$\n" unRemoveFromPath_dosLoop
      StrCmp $3 "$0$\n" unRemoveFromPath_dosLoop
      StrCmp $3 "$0" unRemoveFromPath_dosLoop
      StrCmp $3 "" unRemoveFromPath_dosLoopEnd
      FileWrite $2 $3
      Goto unRemoveFromPath_dosLoop

    unRemoveFromPath_dosLoopEnd:
      FileClose $2
      FileClose $1
      StrCpy $1 $WINDIR 2
      Delete "$1\autoexec.bat"
      CopyFiles /SILENT $4 "$1\autoexec.bat"
      Delete $4
      Goto unRemoveFromPath_done

  unRemoveFromPath_NT:
    StrLen $2 $0
    ReadRegStr $1 HKCU "Environment" "PATH"
    Push $1
    Push $0
    Call un.StrStr ; Find $0 in $1
    Pop $0 ; pos of our dir
    IntCmp $0 -1 unRemoveFromPath_done
      ; else, it is in path
      StrCpy $3 $1 $0 ; $3 now has the part of the path before our dir
      IntOp $2 $2 + $0 ; $2 now contains the pos after our dir in the path (';')
      IntOp $2 $2 + 1 ; $2 now containts the pos after our dir and the semicolon.
      StrLen $0 $1
      StrCpy $1 $1 $0 $2
      StrCpy $3 "$3$1"

      WriteRegExpandStr HKCU "Environment" "PATH" $3
      SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

  unRemoveFromPath_done:
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; IsNT - Returns 1 if the current system is NT, 0
;        otherwise.
;     Output: head of the stack
;====================================================
Function IsNT
  Push $0
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 IsNT_yes
  ; we are not NT.
  Pop $0
  Push 0
  Return

  IsNT_yes:
    ; NT!!!
    Pop $0
    Push 1
FunctionEnd

;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function un.StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  unStrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 unStrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 unStrStr_done unStrStr_loop

  unStrStrReturn_notFound:
    StrCpy $2 -1

  unStrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd

;====================================================
; IsNT - Returns 1 if the current system is NT, 0
;        otherwise.
;     Output: head of the stack
;====================================================
Function un.IsNT
  Push $0
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 unIsNT_yes
  ; we are not NT.
  Pop $0
  Push 0
  Return

  unIsNT_yes:
    ; NT!!!
    Pop $0
    Push 1
FunctionEnd

Section Uninstall
  RMDir /r "$INSTDIR"

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Portable.NET"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\cscc.exe"
  SetAutoClose true
SectionEnd
